/*
Copyright Renaud GICQUEL 2005-2006  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import extThopt.*;
import java.util.*; 
import com.sun.java.swing.*;

/**
 * classe de calcul de la raction de conversion du CO en CO2
 * 
 * @author Renaud GICQUEL
 */
public class ShiftCO extends ExtProcess implements Inversable
{
    
    double Tamont, Taval, Pamont, Paval,Hamont;
    Vector inputComp;
    Vector outputComp;
    double fractH2O,fractCO,fractH2,fractCO2,inert;
    double alpha,beta,lambda,gamma;
    
    public ShiftCO (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,400,300);

		type=getType();
   		thermoCouplerTypes=new String[0];//no thermocoupler connected
    }
    
    public String getType(){
        return "CO shift conversion";
    }
    
  	public String getClassDescription(){
	    return "CO shift conversion (without thermocoupler)\n\nauthor : R. Gicquel  march 2005\n\nRef : archive ShiftCO.zip";
	}

    protected double getKp(double T){
        double lnKp = -3.5741372 + 3642.4848/T   + 292592.85/T/T; //T en K. valeurs perso pour les paramtres
        // optimiss pour le domaine 600  700 C (cart rel.<0,05 %)
        // entre 500 et 800C : cart rel. <0.8 % et entre 400 et 900C : cart rel. <2%
        return Math.exp(lnKp);
    }
    
 
    protected double getKp(double k, double alpha, double beta, double lambda){
        double b,c;
        b=(lambda-1.+k)*k;
        c=(beta+1.-k)*(alpha+1.-k);
        return c/b;
    }
 
    protected double getTfromKp(double Kp){
        double a=292593.,b=3710.59,c,delta;
        c=-3.69088-Math.log(Kp);
        delta=b*b-4*a*c;
        double T= (-b+Math.pow(delta, 0.5))/2/a;
        return 1./T;
    }
    
    protected double get_k(double Kp, double alpha, double beta, double lambda){
        double a,b,c,delta;
        a=Kp-1.;
        b=beta+alpha+2.+(lambda-1.)*Kp;
        c=-(beta+1.)*(alpha+1.);
        delta=b*b-4*a*c;
        double k= (-b+Math.pow(delta, 0.5))/2/a;
        return k;
    }
    
    
	public void calculateProcess(){
        String[] args=new String[2];
        args[0]="process";//type of the element (see method getProperties(String[] args))
        args[1]=tfe.getCompName();//name of the process (see method getProperties(String[] args))
        Vector vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(3);
        double flow=f.doubleValue();
        String amont=(String)vProp.elementAt(1);//gets the upstream point name
        String aval=(String)vProp.elementAt(2);//gets the downstream point name
        getPointProperties(amont);//direct parsing of point property vector
        Tamont=Tpoint;
        Pamont=Ppoint;
        Hamont=Hpoint;
        getSubstProperties(nomCorps);
        if(typeSubst==4){//le corps d'entre est un gaz compos
            
            //initialisations pour la dtermination de la raction
            inputComp=lecorps.getGasComposition();
            outputComp=lecorps.getGasComposition();//le gaz aval aura les mmes composants que le gaz amont
            fractH2O=Util.molarComp(inputComp,"H2O");
            fractCO=Util.molarComp(inputComp,"CO");
            fractH2=Util.molarComp(inputComp,"H2");
            fractCO2=Util.molarComp(inputComp,"CO2");
            inert=1.-fractH2O-fractCO-fractH2-fractCO2;
	        if(fractCO*fractH2O!=0){//le gaz en entre contient CO et H2O
	            alpha=fractH2/fractCO;
	            beta=fractCO2/fractCO;
	            lambda=fractH2O/fractCO;
	            
	            if(lambda>=1){

                    getPointProperties(aval);//direct parsing of point property vector
                    
                    double k=Util.dicho_T (this,0.,1., "calcShift",0.01, 0.999,0.001);//calcul de k
                    
                    tfe.setupPointAval(getProperties());//mise  jour de la transfo et du point aval
                }
                else{//le gaz en entre ne contient pas suffisamment de H2O
	                String msg = "Error: the inlet gas dos not enough H2O\n\nThe reaction cannot be calculated";
	                JOptionPane.showMessageDialog(tfe, msg);  
                }
	        }
	        else{//le gaz en entre ne contient pas de CO ou pas de H2O
	            String msg = "Error: the inlet gas dos not include CO or H2O";
	            JOptionPane.showMessageDialog(tfe, msg);  
	        }
	    }
	    else{//le corps d'entre n'est pas un gaz compos
	        String msg = "Error: the inlet substance is not a compound gas";
	        JOptionPane.showMessageDialog(tfe, msg);  
	    }
	}
	
    
    
    public double f_dicho(double k, double T,String fonc){
        
        if (fonc.equals("calcShift"))return CalculateOneStep(k);

        return 0;
    }
	
	protected double CalculateOneStep(double k){
            double Kp=1;
            Kp=getKp(k, alpha, beta, lambda);//estimation de Kp
            double T=getTfromKp(Kp);//estimation de T
            
            //recherche de la composition des produits pour k
	        double xCO=k*fractCO;
	        double xCO2=(beta+1-k)*fractCO;
	        double xH2=(alpha+1-k)*fractCO;
	        double xH2O=(lambda-1+k)*fractCO;
 
            //mise  jour de la composition du corps aval
	        Util.updateMolarComp(outputComp,"H2O", xH2O);
	        Util.updateMolarComp(outputComp,"H2", xH2);
	        Util.updateMolarComp(outputComp,"CO", xCO);
	        Util.updateMolarComp(outputComp,"CO2", xCO2);
            lecorps.updateGasComposition(outputComp);
            getSubstProperties(nomCorps);
            
            //calcul de la temprature du point aval
            double Q_mol=fractCO*(1-k)*41170;//chaleur libre par kmol de gaz entrant
            double Q_mass=Q_mol/Msubst;//chaleur libre par kg de gaz entrant
	        double h_out=Hamont+Q_mass;
	        Tpoint=lecorps.getT_from_hP(h_out,Ppoint);
	        
	        return T-Tpoint;//cart entre les tempratures calcules des deux manires
	    
	}
    
 

}